
void ChassisGoDistanceDual(int lock_angle, int distance, int speed) {
  distance = int(float(distance) * 2.174 / 1.6);
  if (distance < 0) {
    ChassisGoDistance(STM32_ADDRESS_1, CHASSIS, CHASSIS_GO_DISTANCE, 180, lock_angle, -distance, speed);
  } else if (distance >= 0) {
    ChassisGoDistance(STM32_ADDRESS_1, CHASSIS, CHASSIS_GO_DISTANCE, 0, lock_angle, distance, speed);
  }
}

void ChassisGoSpeed(uint8_t address, uint8_t chassis, uint8_t chassis_cmd, float angle, float angle_lock, int distance, int speed_rate, int init_speed) {
  uint8_t* msg = createChassisGoDistanceMsg(address, chassis, chassis_cmd, angle, angle_lock, distance, speed_rate, init_speed);  // 设置速度PID参数

  // 发送控制底盘的指令
  Wire.beginTransmission(address);     // 打开与地址为0x01的设备的通信
  Wire.write(msg, 12);                 // 发送3个字节的数据
  Serial.println("Send chassis cmd");  // 打印空格，方便查看每个数据
  Wire.endTransmission();              // 关闭通信
}

void ChassisGoSpeedDual(int lock_angle, int speed, String side_choice) {
  int distance = int(100000);
  if (distance < 0) {
    ChassisGoSpeed(STM32_ADDRESS_1, CHASSIS, CHASSIS_GO_DISTANCE, 180, lock_angle, -distance, speed);
  } else if (distance >= 0) {
    if (speed < 0) {
      ChassisGoSpeed(STM32_ADDRESS_1, CHASSIS, CHASSIS_GO_DISTANCE, 0, lock_angle, distance, -speed);
    } else {
      ChassisGoSpeed(STM32_ADDRESS_1, CHASSIS, CHASSIS_GO_DISTANCE, 180, lock_angle, distance, speed);
    }
  }

  while (1) {
    if (side_choice = "zuo") {
      if (gw_linesensor.readSensorState(0) == false) {
        stopDual();
        break;
      }
    }

    if (side_choice = "you") {
      if (gw_linesensor.readSensorState(7) == false) {
        stopDual();
        break;
      }
    }
  }
}

void releaseDual(GrayScaleSensor sensor = gw_linesensor) {
  ChassisRelease(STM32_ADDRESS_1, CHASSIS, CHASSIS_RELEASE, 0, " 0", 0, sensor);
}

// 循迹多少距离
void lineFollowPIDDistanceSpeedDual(int32_t distance, int target_speed, float acceleration) {
  // 获取此时的位置
  releaseDual();
  delay(5);
  Position chassis_position = ReadChassisDistance(STM32_ADDRESS_1, CHASSIS, CHASSIS_READ_POSI_STATE);
  int chassis_x_now = chassis_position.x;

  float current_speed = 0;  // 初始速度设置为0

  float linePosition_2 = 0;
  float reference = 0;
  float e2 = 0;

  while (1) {
    // 获取灰度数值
    linePosition_2 = gw_linesensor.readWeightedAverage();
    e2 = reference - linePosition_2;  // second error

    // 计算PID数值
    int ctrl;
    ctrl = xunji.calcPid(e2);

    // 逐渐增加速度直到达到目标速度
    current_speed += acceleration;
    if (current_speed > target_speed) {
      current_speed = target_speed;  // 确保速度不超过目标速度
    }

    // 角度锁定的矢量控制
    // 实际去控制轮子的转速
    // ctrl = 3;
    // ++ --
    PIDSpeedCtl(STM32_ADDRESS_1, MOTOR_ID_0, current_speed - ctrl);
    PIDSpeedCtl(STM32_ADDRESS_1, MOTOR_ID_1, -current_speed - ctrl);

    Serial.println(ctrl);

    delay(5);

    Position chassis_position_check = ReadChassisDistance(STM32_ADDRESS_1, CHASSIS, CHASSIS_READ_POSI_STATE);
    // 循迹检测是否已经达到了指定的长度

    if ((chassis_position_check.x - chassis_x_now) > float(distance)) {
      break;
    }
  }
}

void lineFollowPIDSideSpeedDual(String side_choice, int target_speed, float acceleration) {
  // 获取此时的位置
  float current_speed = 0;  // 初始速度设置为0

  float linePosition_2 = 0;
  float reference = 0;
  float e2 = 0;

  while (1) {
    // 获取灰度数值
    linePosition_2 = gw_linesensor.readWeightedAverage();
    e2 = reference - linePosition_2;  // second error

    // 计算PID数值
    int ctrl;
    ctrl = xunji.calcPid(e2);

    // 逐渐增加速度直到达到目标速度
    current_speed += acceleration;
    if (current_speed > target_speed) {
      current_speed = target_speed;  // 确保速度不超过目标速度
    }

    // 角度锁定的矢量控制
    // 实际去控制轮子的转速
    // ctrl = 3;
    // ++ --
    PIDSpeedCtl(STM32_ADDRESS_1, MOTOR_ID_0, current_speed - ctrl);
    PIDSpeedCtl(STM32_ADDRESS_1, MOTOR_ID_1, -current_speed - ctrl);

    Serial.println(ctrl);

    delay(5);

    if (side_choice = "zuo") {
      if (gw_linesensor.readSensorState(0) == false) {
        break;
      }
    }

    if (side_choice = "you") {
      if (gw_linesensor.readSensorState(7) == false) {
        break;
      }
    }

    if (side_choice = "mid") {
      if (gw_linesensor.readSensorState(3) == false && gw_linesensor.readSensorState(4) == false && gw_linesensor.readSensorState(2) == false && gw_linesensor.readSensorState(5) == false) {
        break;
      }
    }

    if (side_choice = "both_sid") {
      if (gw_linesensor.readSensorState(0) == false && gw_linesensor.readSensorState(7) == false && gw_linesensor.readSensorState(2) == false && gw_linesensor.readSensorState(5) == false) {
        break;
      }
    }
  }
}

void stopDual() {
  StopCtl(STM32_ADDRESS_1, MOTOR_ID_0);
  StopCtl(STM32_ADDRESS_1, MOTOR_ID_1);
}

void turnToAngleDual(float target_angle, String turn_state, float speed_rate, GrayScaleSensor sensor) {
  ChassisTurnAngleWoLock(STM32_ADDRESS_1, CHASSIS, CHASSIS_TURN_ANGLE_WITH_LOCK, target_angle, turn_state, speed_rate, sensor);
}

void angleLockDual(float lock_angle) {
  ChassisAngleLock(STM32_ADDRESS_1, CHASSIS, CHASSIS_ANGLE_LOCK, lock_angle);
}

// 左边轮子
void ZuoLunSuDu(int current_speed){
  PIDSpeedCtl(STM32_ADDRESS_1, MOTOR_ID_0, current_speed);
}

void YouLunSuDu(int current_speed){
  PIDSpeedCtl(STM32_ADDRESS_1, MOTOR_ID_0, current_speed);
}

